REBOL [
	Title: "Simple Ball Game"
	File: %Ballgame.r
	Date: 16-Jan-2000
	Purpose: {Hit the moving ball.}
]

backdrop: none

view-size: 640x480

img: load %ball.gif

ball: make face [
	offset: 100x100
	size: 40x40
	body: make body [image: img color: none effect: [key 255.255.255]]
	edge: none
]

paddle: make face [
	offset: view-size - 300x60
	size: 100x24
	body: make body [color: 240.140.40]
	edge: make edge [color: complement body/color]
]

score: make face [
	size: 60x40
	offset: view-size - size
	body: edge: none
	font: make font [size: 32 style: 'bold color: 200.200.200]
	text: 0
]

high-score: make score [
	offset: view-size - size * 0x1
]

face: make face [
	body: make body [
		color: 0.0.100
		if all [backdrop exists? backdrop] [image: load backdrop effect: [colorize 0.75.140]]
	]
]

way: 1x1
speed: 3x3
hits: 0

do-events: func [/local event-port event xy n][
    event-port: open [scheme: 'event]
    forever [
        wait [ event-port ]
		event: first event-port
		if event/type = 'quit [ break ]
		if event/type = 'time [
			paddle/offset:
				(event/offset - (paddle/size / 2) * 1x0) + (paddle/offset * 0x1)
			show paddle

			xy: ball/offset + (speed * way)
			either all [
				(xy/x + ball/size/x) > paddle/offset/x  
				xy/x < (paddle/offset/x + paddle/size/x)
				(xy/y + ball/size/y) > paddle/offset/y
				(xy/y + ball/size/y) < (paddle/offset/y + 10)
			][
				way: way * 1x-1
				score/text: hits: hits + 1
				if hits > high-score/text [high-score/text: hits show high-score]
				show score
				if all [hits < 10 zero? (hits // 3)] [speed: speed + 1x1]
				paddle/size: paddle/size - 1x0
				show paddle
			][
				n: view-size/x - ball/size/x
				if any [xy/x < 0 xy/x > n] [way: way * -1x1]
				if xy/y < 0 [way: way * 1x-1]
				if xy/y > view-size/y [
					score/text: hits: 0
					show score
					wait 1 speed: 3x3 way: 1x1 
					xy: 0x0
					paddle/size: 100x24
					show paddle
				]
				ball/offset: xy
			]
			show ball
		]
    ]
    close event-port
    event
]

view/size reduce [ball paddle score high-score] view-size


