REBOL [
    Title: "Book"
    Purpose: "A small text viewer"
    Date: 25-Jan-2000
]

split-pages: func [file /local txt m1 m2][
    if error? try [m1: txt: read file][exit]
    pages: copy []
    until [m2: any [find/tail skip m1 550 " " skip m1 550]
            append pages copy/part m1 m2 tail? m1: m2]
]

stylize [
    page frame  [
		body: [color: 200.200.200]
    	font: [color: black size: 12 align: 'left style: 'bold valign: 'top]
    ]
]

index: 0

move: func [dir][
    all [not value? 'pages return]
    if all pick [[index <= length? pages][index > 0]] dir [
        stuff/text: pick pages index: index + pick [1 -1] dir
    ] page-count/text: reform [index #of length? pages] 
    show stuff show page-count
]

view layout 640x480 [
    backdrop 30.50.80
    title "Book"
    button "Quit" [quit]  
    label "Textfile to view:"
    entry: field [split-pages to-file entry/text move true] 100x20
    button "Next" [move true]
    button "Prev" [move false]
    page-count: text "" 100x40
    at 140x40 stuff: page 400x420
]
