REBOL [
    Title: "Viewable Online Dictionary"
    Comment: "First defines dict:// protocol"
    Purpose: "Look up words with easy to use GUI"
    Date: 26-Jan-2000
]

dict-site: dict://stn.dict.org/
make Root-Protocol [
    Scheme: 'dict
    Port-id: 2628
    Port-flags: system/standard/port-flags/direct

    open-check: [none "220" "CLIENT REBOL" "250"]
    read-def: func [
        "Read a definition from the DICT server"
        port [port!]
        buf [string!]
        /local line
    ][
        while ["." <> line: system/words/pick port 1][
            foreach item (reduce [line newline]) [
                system/words/insert tail buf item
            ]
        ] buf
    ]
    read: func [
        port [port!]   "The port object"
        data [string!] "A buffer"
        /local type word db strat response 
        match-check define-check showdb-check
    ][
        define-check: [reform ["DEFINE" any [db "!"] word] ["150" "151" "55"]]
        match-check:  [
            reform ["MATCH" any [db "!"] any [strat "."] word ] ["152" "552"]
        ]
        showdb-check: ["SHOW DB" ["110" "554"]]
        set [type word db strat] either all [port/target find port/target ":"][
            parse/all port/target ":"
        ][
            either port/target [["d" port/target]][none]
        ]        
        response: net-utils/confirm port/sub-port any [ 
            all [type = "d" reduce define-check] 
            all [type = "m" reduce match-check] 
            showdb-check
        ]
        any [
            all [
                any [type = "d" type = "m"]
                either none? find/match response "15" [
                    clear data 
                ][
                    loop either any [type = "m" find/match response "151"] [1][
                        to-integer second parse response none
                    ][read-def port/sub-port data]
                ]
            ]
            read-def port/sub-port data
        ]
    ]
    net-utils/net-install dict self 2628
]

stylize [answer frame [font: [size: 8 align: 'left valign: 'top shadow: 2x2]]]
view layout 640x480 [
    backdrop (random 255.255.255)
    title "Dictionary"
    button "Quit" [quit]  
    label "Word to look up?"
    entry: field [
        error? try [stuff/text: read rejoin [dict-site entry/text]]
        if any [none? stuff/text empty? stuff/text][stuff/text: "Not found"]
        entry/text: copy "" show stuff
    ] 100x20 at 140x40
    stuff: answer 400x420
]
