REBOL [
    Title:   "Iterated random overlays"
    Purpose: "Overlays on image with random effects"
    Date:    25-Jan-2000
]
ws: 400x400
random-effect: func [][
    result: copy [] box: 
    loop random 4 [
        append result pick compose/deep [
            [colorize (random 255.255.255)] blur hflip 
            [multiply (random 255.255.255)] vflip] random 5
    ]
]
stylize [rand-spot frame [size: 50x50 action: [show lower] (body/image: edge: none)]]
layout ws upane: [top: title "Click for effect" rs: rand-spot]
iterate: func [ face index /local nvert box][
        box: copy []
        nvert: face/size/y / 50
        column: to-integer ( index - 1 ) / nvert
        row: ( index - 1 ) // nvert
        if column >= ( face/size/x / 50 ) [ return none ]
        rs/offset: to-pair reduce [ column * 50 row * 50 ]
        rs/body/effect: random-effect
        my-pane
]
my-pane: [ rs ]
lower: make face [
    offset: 0x0 size: ws 
    pane: :iterate body: make body [image: load %../face/bay.jpg effect: 'fit]
]
upper: make face [size: ws pane: append reduce [lower] top]
view/size upper ws


