REBOL [
    Title:   "Run away"
    Purpose: "Annoying little demo of using over"
    Date: 25-Jan-2000
]
ws: 450x450

repair: func [blk][to-pair reduce blk]
foreach [name blk][
    down  [0 random 40]
    up    [0 negate random 40]
    right [random 40 0]
    left  [negate random 40 0]
][set name func [] append/only copy [repair] blk] 

direction: right
directions: [down up right left]
escape: func [
    "run away in confined space"
    min max pos /local x
][
    all [pos/x > min/x pos/y > min/y pos/x < max/x pos/y < max/y
	 return pos + either random true [direction][
	    direction: pick reduce directions random 4]]
    dir: copy []
    foreach [p1 op p2 sp more dxy][
	pos/x <= min/x min/x: + right pos/y <= min/y min/y: + down
	pos/x >= max/x min/x: - left  pos/y >= max/y min/y: - up
    ][all compose [(:p1) (:op) (:p2) (:sp) (:p2) (:more) 40 append dir (:dxy)]]
    x: pos + direction: pick reduce x: either empty? dir [directions][dir] 
        random length? x
]

run-feel: make system/standard/face/feel [
    engage: func [face action event index][if action = 'up [view layout ws me]]
    over: func  [ face how pos index ][
	face/offset: escape 20x20 ((ws - 20x20) - 40x40) face/offset 
	show face
    ]
]
stylize [
    haha backdrop [size: (ws) action: [print "Missed!"]]
    runner frame [
	size: 30x30 feel: (run-feel) color: 223.23.0 
	text: "Catch me" font: [size: 6]]
]
view/size layout ws me: [haha (random 255.255.255) at 60x60 runner] ws

