REBOL [
	Title: "Simple Image Viewer"
	File: %view.r
	Purpose: {Shows jpeg, gif, bmp from a directory.}
]

page-size: 800x600

image-file?: func ["Returns true if file is an image" file] [
	find [%.bmp %.jpg %.jpeg %.gif] find/last file "."
]

;-- Read local file list, but want just image files...
files: read %.
while [not tail? files] [
	either image-file? first files [files: next files][remove files]
]
files: head files
if empty? files [quit]

pane: layout page-size [
	backtile %rice.jpg 100.100.100
	origin 10x10
	the-image: image (first files)
	across
	at (page-size * 0x1 + 10x-30)
	button "Next" [
		files: next files
		if not tail? files [
			the-image/body/image: load first files
			show the-image
		]
	]
	button "Back" [
		if not head? files [
			if tail? files [files: back files]
			files: back files
			the-image/body/image: load first files
			show the-image
		]
	]
]

view/size pane page-size
