REBOL[
	Title: "Email Buttons"
	File:  %buttons.r
	Date:  12-Jan-2000
	Purpose: {Makes several buttons for sending email.}
]

for-real: false

button: make face [
	size: 100x24
	text: "Button"
	body: make body [color: 240.160.60]
	edge: make edge [effect: 'bezel]
	feel: make feel [
		redraw: func [face idx][
			face/edge/effect: pick [ibezel bezel] face/data
		]
		engage: func [face act evt idx][
			act: switch/default act [
				down [on]
				over [on]
				up [if face/data [
						either for-real [do face/action][face/action]
					] off
				]
			][off]
			if act <> face/data [
				face/data: act
				show face
			]
		]
	]
	data: off
	action: [print "Do the action."]
]

where: 40x40
buttons: []
database: [
	"Webmaster" webmaster@rebol.com
	"Info" info@rebol.com
	"Luke" luke@rebol.com
	"Docs" docs@rebol.com
	"Feedback" feedback@rebol.com
]
msg: "Test of REBOL/View, ignore it."

foreach [name email] database [
	where: where + 0x30
	append buttons make button [
		offset: where
		text: name
		action: compose [send (email) (msg)]
	]
]

view/size buttons 180x300

