REBOL [
	Title: "RGB Colorizer"
	File: %colorize.r
	Date: 15-Jan-2000
]

img: load %bay.jpg

confine: func [
	"Keep area of a given size in-bounds."
	offset size origin margin /local n
][
	if offset/x < 0 [offset: offset * 0x1]
	if offset/y < 0 [offset: offset * 1x0]
	n: margin/x - size/x
	if offset/x > n [offset: offset/x: n]
	n: margin/y - size/y
	if offset/y > n [offset: offset/y: n]
	offset
]

color-value: 255.255.255

drag-r: make face [
	base: offset: 2x2
	which: 1
	size: 10x30
	body: make body [color: 250.0.0]
	edge: make edge [effect: 'ibezel]
	feel: make feel [
		engage: func [face action event index /local n][
			either none? face/data [
				face/data: event/offset
			][
				face/offset: face/base + (0x1 * confine face/offset + event/offset - face/data
					face/size face/base fence/size - 4x4)
				n: 255 - to-integer (face/offset/y - 2)
				face/body/color: poke 0.0.0 face/which n
				num-face/text: clr-face/body/color: color-value: poke color-value face/which n
				clr-face/body/effect: compose [colorize (color-value)]
				show face
				show num-face
				show clr-face
			]
			if action = 'up [face/data: none]
		]
	]
]

drag-g: make drag-r [
	base: offset: 12x2
	which: 2
	body: make body [color: 0.250.0]
]	

drag-b: make drag-r [
	base: offset: 22x2
	which: 3
	body: make body [color: 0.0.250]
]	

fence: make face [
	offset: 50x50
	size: 35x289
	body: make body [color: 50.100.150]
	edge: make edge [effect: 'bezel]
	pane: reduce [drag-r drag-g drag-b]
]

clr-face: make face [
	offset: 100x120
	size: img/size
	body: make body [color: 0.0.0 image: img effect: [colorize 255.255.255]]
	edge: make edge [effect: 'ibezel]
]

num-face: make face [
	offset: 100x80
	size: 100x20
	text: color-value
	body: make body [color: 200.180.160]
	edge: make edge [effect: 'ibezel]
	font: make font [style: 'bold size: 14]
]

view/size reduce [num-face clr-face fence] 320x400


