REBOL[
	Title: "Drag N Size"
	Date: 26-Jan-2000
	File: %drag-n-size.r
	Purpose: {
		Show how to drag and resize a box.
	}
]

confine: func [
	"Keep area of a given size in-bounds."
	offset size origin margin
][
	if offset/x < origin/x [offset/x: origin/x]
	if offset/y < origin/y [offset/y: origin/y]
	margin: margin - size
	if offset/x > margin/x [offset/x: margin/x]
	if offset/y > margin/y [offset/y: margin/y]
	offset
]

drag: make face [
	size: 100x100
	pane: none
	body: make body [color: 40.150.200]
	text: "Click in the middle to drag^/and on the bottom right to size!"
	edge: make edge [color: 0.0.0]
	feel: make feel [
		engage: func [ face action event ][
			switch/default action [
				down [
					either event/offset < ( size - 4 ) [
						data: event/offset
					][
						size: ( confine event/offset + offset 1x1
								offset + 20 main-view-face/size ) - offset
					]
				]
				up [
					either data [
						data: none
					][
						size: ( confine event/offset + offset 1x1
								offset + 20 main-view-face/size ) - offset
					]
				]
			][
				either data [
					offset: confine offset + (event/offset - data)
						size 0x0 main-view-face/size
				][
					size: ( confine event/offset + offset 1x1
							offset + 20 main-view-face/size ) - offset
				]
			]
			show face
		]
	]
]


view drag

