REBOL [
	Title: "Drag Test"
	File: %drag.r
	Date: 15-Jan-2000
	Purpose: {Drag the boxes around.}
]

confine: func [
	"Keep area of a given size in-bounds."
	offset size origin margin /local n
][
	if offset/x < 0 [offset: offset * 0x1]
	if offset/y < 0 [offset: offset * 1x0]
	n: margin/x - size/x
	if offset/x > n [offset: offset/x: n]
	n: margin/y - size/y
	if offset/y > n [offset: offset/y: n]
	offset
]

drag1: make face [
	offset: 100x100
	size: 50x50
	body: make body [color: 200.40.20]
	text: "DRAG ME"
	feel: make feel [
		engage: func [face action event index][
			either none? face/data [
				face/data: event/offset
			][
				face/offset: confine face/offset + (event/offset - face/data)
					face/size 0x0 fence/size
				show face
			]
			if action = 'up [face/data: none]
		]
	]
]

drag2: make drag1 [offset: 250x100 body: make body [color: 40.200.20]]

fence: make face [
	offset: 50x50
	size: 640x480 - 100x100
	body: make body [color: 50.100.150]
	edge: none
	pane: reduce [drag1 drag2]
]

view fence

