REBOL [
	Title: "Varies Face Look"
	File: %facelook.r
	Date: 15-Jan-2000
	Purpose: {Shows major face variations.}
]

face-body: face/body
face-edge: face/edge

pic: load 64#{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}

faces: reduce [
	dup-face: make face [
		offset: 1000x1000
		size: 5000x3000
		text: "FACE-1"
		body: none
		edge: none
		font: make font [color: 255.255.255 shadow: 150x150 name: "arial" style: 'bold]
	]

	make dup-face [
		offset: offset + size
		body: make face-body [color: 40.150.180]
		text: "FACE-2"
	]

	make dup-face [
		offset: offset + (2 * size)
		edge: make face-edge [size: 200x200 color: 255.255.0]
		text: "FACE-3"
	]

	make dup-face [
		offset: offset + (3 * size)
		body: make face-body [image: pic effect: 'fit]
		text: "FACE-4"
	]

	make dup-face [
		offset: offset + (4 * size)
		body: make face-body [image: pic effect: [colorize 0.120.255]]
		edge: make face-edge [size: 200x200 color: 255.120.0]
		text: "FACE-5"
	]

	make dup-face [
		offset: offset + (5 * size)
		body: make face-body [color: 0.200.200]
		edge: make face-edge [size: 500x500 image: pic effect: [fit colorize 250.80.40]]
		text: "FACE-6"
	]
]

view-face: make face [
	offset: 100x100
	size: 640x400
	span: 32000x24000
	pane: faces
	body: make body [color: 50.50.150]
	edge: none
	text: system/script/header/title
]

show view-face
do-events
hide view-face

