REBOL[
	Title: "Script Launcher"
	File:  %launch.r
	Date:  28-Jan-2000
	Author: "Jim Goodnow II"
	Purpose: {Launches scripts found in the current directory.}
]

make object! [		; the time honored way to hide some names...

	selected: 0
	stop: false

	my-do-events: func[/local event-port event][
		event-port: open [ scheme: 'event ]
		forever [
			wait event-port
			event: first event-port
			if any [ stop event/type = 'quit ] [ break ]
			do event
		]
		close event-port
	]

	button-iterator: func [ face iter /local col row ][
		if iter > length? scripts [ return none ]
		button/text: to-string pick scripts iter
		nrows: to-integer ( face/size/y - 6 ) / ( button/size/y + 6 )
		iter: iter - 1		; make it zero based
		button/offset/x: 10 + ( ( to-integer ( iter / nrows ) ) *
												( button/size/x + 10 ) )
		button/offset/y: 6 + ( ( iter // nrows ) * ( button/size/y + 6 ) )
		button
	]

	button: make face [
		offset: 40x40
		size: 100x24
		text: ""
		body: make body [color: 240.160.60]
		edge: make edge []
		feel: make feel [
			redraw: func [face pos idx][
				face/edge/effect: either all[
						idx = selected face/data]['ibezel]['bezel]
			]
			engage: func [face act evt idx ][
				act: switch/default act [
					down [selected: idx on ]
					over [on]
					up [
						if face/data [
							stop: true
						]
						off
					]
				][off]
				if act <> face/data [
					face/data: act
					show/index main-view-face idx
				]
			]
		]
		data: off
	]

	save-events: :do-events

	if not error? try [ scripts: load %. ][
		while [ not tail? scripts ][
			either %.r = find/last first scripts "." [
				scripts: next scripts
			][
				remove scripts
			]
		]
		scripts: sort head scripts
		forever [
			do-events: :my-do-events
			view/size/offset :button-iterator 450x312 100x100
			do-events: :save-events
			either stop [
				do pick scripts selected
				selected: 0
				stop: false
			][ break ]
		]
	]
]

