REBOL [
    Title:   "Multi Webcam Viewer"
    Date:    26-Jan-2000
    Author:  "Bohdan Lechnowsky"
    Email:   bo@rebol.com
    File:    %multicam.r
    Purpose: {To view any number of webcams simultaneously.}
]

cams: [
    http://www.mte.com/webcam/5thave.jpg
    http://www.toronto.com/camera2/fullsize.jpg
    http://204.176.110.105/camera/capture.jpg
    http://www.waxmuseum.com/waxcam.jpg
    ;http://www.execpc.com/~dschaaf/az_mem3.jpg
    ;http://www.discoveromaha.com/cgi-bin/cams/nph-campush?full_cam1
]

main: make face [
	size: 24000x24000
    pane: []
	rate: 1
	feel: make feel [
		redraw: func [][
			redraw: none
			show main
		]
		engage: func [face act evt index /local img][
			if evt/type = 'time [
					foreach face main/pane [
				    	face/body/image: either error? try [
				    		img: load read/binary face/text][none][img]
				        show main
				    ]
			]
		]
	]
]

camface: make face [
	edge: make edge [size: 100x100 color: 0.0.0]
	font: make font [valign: 'bottom color: 200.200.0 shadow: 50x50 style: 'bold]
]

makecams: func [][
    xoff: yoff: 0
    delta: (to-integer 24000 / to-integer .99 + square-root length? cams) + 1
    foreach cam cams [
        append main/pane make camface [
            offset: make pair! reduce [xoff yoff]
            size: make pair! reduce [delta delta]
            body: make body [
				color: random 255.255.255
            	effect: 'fit
            ]
			text: cam
        ]
        if (xoff: xoff + delta) >= 24000 [xoff: 0 yoff: yoff + delta]
    ]
]

makecams
view/span/size main 24000x24000 800x600