REBOL [
    Title:   "A Different Multi Webcam Viewer"
    Date:    27-Jan-2000
    Author:  "Jim Goodnow II"
    Email:   jimg@rebol.com
    File:    %multicam2.r
    Purpose: {
        To view up to six webcams simultaneously.
    }
]


cams: [
    http://www.mte.com/webcam/5thave.jpg
    http://www.toronto.com/camera2/fullsize.jpg
    http://www.execpc.com/~dschaaf/az_mem3.jpg
    http://204.176.110.105/camera/capture.jpg
    ;http://www.waxmuseum.com/waxcam.jpg
    ;http://www.discoveromaha.com/cgi-bin/cams/nph-campush?full_cam1
]

images: reduce [ none none none none none none ]

load-images: func[/local cam pic image ][
	image: images
	foreach cam cams [
		if error? try [ pic: load cam ][
			pic: none
		]
		change image pic
		show main
		image: next image
	]
]

cam-iterator: func [ face iter ][
	if iter > 6 [ return none ]
	camface/offset/x: ( ( iter - 1 ) // 3 ) * 200
	camface/offset/y: ( to-integer ( ( iter - 1 ) / 3 ) ) * 200
	camface/body/image: pick images iter
	either none? camface/body/image [
		camface/text: "no signal"
		camface/body/effect: none
	][
		camface/text: none
		camface/body/effect: 'fit
	]
	camface
]

main: make face [
	offset: 0x0
    size: 600x400
	body: make body [ color: 255.0.0 ]
	edge: none
	pane: :cam-iterator
	rate: 0:0:20			; tap us once every 20 seconds
	feel: make feel [
		engage: func [ face what event ][
			if event/type = 'time [
				load-images
			]
		]
	]
]

camface: make face [
	offset: 0x0
	size: 200x200
	edge: make edge [ color: 128.128.128 ]
	body: make body [
		image: none
		effect: none
		color: 0.0.0
	]
	font: make font [ color: 200.200.200 ]
]

show main
load-images
do-events
hide main
