REBOL [
    Title:   "Multiple Images From a Webcam Viewer"
    Date:    27-Jan-2000
    Author:  "Jim Goodnow II"
    Email:   jimg@rebol.com
    File:    %multicam3.r
    Purpose: {
        To view the last six images from a webcam.
    }
]


; pick a site any site...
cams: [
    http://www.mte.com/webcam/5thave.jpg			; ??
    http://www.toronto.com/camera2/fullsize.jpg		; toronto
    http://www.discoveromaha.com/cgi-bin/cams/nph-campush?full_cam1
    http://www.waxmuseum.com/waxcam.jpg				; embarcadero
    http://www.execpc.com/~dschaaf/az_mem3.jpg		; hawaii
    http://204.176.110.105/camera/capture.jpg		; chicago
]

images: []
times: []

last-image: none

next-image: func[/local pic ][
	if all [
		not error? try [ pic: load first cams ]
		pic <> last-image
	][
		if 6 = length? images [
			remove images
			remove times
		]
		append images pic
		append times now
		last-image: pic
	]
]

cam-iterator: func [ face iter ][
	if iter > 6 [ return none ]
	time-face/offset:
	cam-face/offset/x: ( ( iter - 1 ) // 3 ) * 200
	cam-face/offset/y: ( to-integer ( ( iter - 1 ) / 3 ) ) * 220
	cam-face/body/image: pick images iter
	time-face/offset/y: cam-face/offset/y + 200
	time-face/text: pick times iter
	reduce [ cam-face time-face ]
]

main: make face [
	offset: 0x0
    size: 600x440
	text: "Multicam-3"
	body: make body [ color: 0.0.0 ]
	edge: none
	pane: :cam-iterator
	rate: 0:0:20			; tap us once every 20 seconds
	feel: make feel [
		engage: func [ face what event ][
			if event/type = 'time [
				next-image
				show main
			]
		]
	]
]

cam-face: make face [
	offset: 0x0
	size: 200x200
	edge: make edge [ color: 0.0.0 ]
	body: make body [
		image: none
		effect: 'fit
	]
]

time-face: make face [
	offset: 0x0
	size: 200x20
	text: ""
]

show main
next-image
show main
do-events
hide main
