REBOL[
	Title: "Popup Menu Example"
	File:  %popup.r
	Date:  28-Jan-2000
	Purpose: {Makes a popup menu.}
]

menu: make face [
	offset: 40x40
	size: 100x24
	text: "Menu"
	body: make body [ color: 240.160.60 ]
	edge: make edge []
	feel: make feel [
		redraw: func [face idx][
			face/edge/effect: pick [ibezel bezel] face/data
		]
		engage: func [face act evt idx][
			act: switch/default act [
				down [
					insert my-pane popup-face
					popup-face/show?: true
					show main-view-face
					on
				]
				up [
					if item/data <> 0 [
						print pick popup-face/data item/data
					]
					item/data: 0
					hide popup-face
					remove my-pane
					off
				]
			][face/data]
			if act <> face/data [
				face/data: act
				show face
			]
		]
	]
	data: off
]
		
popup-iterator: func [ face iter /local col row ][
	if iter > length? face/data [ return none ]
	item/text: pick face/data iter
	item/offset/y: 2 + ( ( iter - 1 ) * item/size/y )
	item
]

popup-face: make face [
	offset: 140x40
	size: 104x148
	edge: make edge [ effect: 'ibezel ]
	body: none
	pane: :popup-iterator
	data: [ "Open" "Close" "Save" "Save As..." "---" "Quit" ]
	show?: on
]

item: make face [
	offset: 2x2
	size: 100x24
	body: make body [color: 240.160.60]
	edge: none
	feel: make feel [
		redraw: func [ face pos iter ][
			face/body/color: pick face/colors ( face/data = iter )
		]
		over: func [face action event iter][
			either action [
				face/data: iter
			][
				face/data: 0
			]
			show/index popup-face iter
		]
	]
	data: 0
	colors: [ 60.160.240 240.160.60 ]
]

view/size my-pane: [ menu ] 300x200

