REBOL[
	Title: "Rotary Button"
	File:  %rotary.r
	Date:  12-Jan-2000
	Purpose: {Makes a rotary button.}
]

button: make face [
	offset: 40x40
	size: 100x24
	body: make body [color: 50.160.130]
	edge: make edge [effect: 'bezel]
	feel: make feel [
		redraw: func [face idx][
			face/text: first face/states
		]
		engage: func [face act evt idx][
			switch act [
				down [
					face/states: next face/states
					if tail? face/states [face/states: head face/states]
					face/edge/effect: 'ibezel
					face/action index? face/states
				]
				up [face/edge/effect: 'bezel]
				away [face/edge/effect: 'bezel]
				over [face/edge/effect: 'ibezel]
			]
			show face
		]
	]
	states: ["Breakfast" "Lunch" "Dinner" "Snack"]
	action: func [state] [print state]
]

view/size button 180x200

