REBOL [
	Title: "Simple Slider Test"
	File: %slider.r
	Date: 15-Jan-2000
	Purpose: {Simple slider constructed from faces.}
]

confine: func [
	"Keep area of a given size in-bounds."
	offset size origin margin /local n
][
	if offset/x < 0 [offset: offset * 0x1]
	if offset/y < 0 [offset: offset * 1x0]
	n: margin/x - size/x
	if offset/x > n [offset/x: n]
	n: margin/y - size/y
	if offset/y > n [offset/y: n]
	offset
]

dragger: make face [
	offset: 2x2
	size: 16x40
	body: make body [color: 200.40.20]
	edge: make edge [effect: 'ibezel]
	feel: make feel [
		engage: func [face action event index][
			either none? face/data [
				face/data: event/offset
			][
				face/offset: 2x2 + confine face/offset + (event/offset * 0x1 - face/data)
					face/size 2x2 fence/size - 4x4
				show face
				num-face/text: to-integer (face/offset/y - 2 * 255 / 156)
				show num-face
				clr-face/body/color: poke 0.0.0 1 num-face/text
				show clr-face
			]
			if action = 'up [face/data: none]
		]
	]
]

fence: make face [
	offset: 50x50
	size: 20x200
	body: make body [color: 50.100.150]
	edge: make edge [effect: 'bezel]
	pane: dragger
]

clr-face: make face [
	offset: 100x120
	size: 100x100
	body: make body [color: 0.0.0]
	edge: make edge [effect: 'ibezel]
]

num-face: make face [
	offset: 100x80
	size: 100x20
	text: 0.0.0
	body: make body [color: 200.180.160]
	edge: make edge [effect: 'ibezel]
	font: make font [style: 'bold size: 14]
]

view reduce [num-face clr-face fence]


